unit tc_util; {$V-}

interface

uses graph,tc_glob;

procedure zoom;
procedure wind;
procedure snap;
procedure options;
procedure quit;

implementation

var last_x0,last_y0,last_zoom_fac:real;

procedure zoom;
var fac_str:string;
    ende,stop:boolean;
    wahl,err_code,sx1,sx2,sy1,sy2:integer;
    x,y,h:real;
begin
ende:=false; wahl:=1;
while not ende do begin
   str(opt.zoom_fac:1:2,funk[0]);
   funk[0]:='ZOOM ('+funk[0]+')';
   funk[1]:='Factor';
   funk[2]:='Area';
   funk[3]:='All';
   funk[4]:='Last';
   menu(4,wahl);
   if (wahl>0) and (wahl<4) then begin
      last_zoom_fac:=opt.zoom_fac;
      last_x0:=x0; last_y0:=y0;
   end;
   case wahl of
      0: ende:=true;
      1: begin
         message('Zoom-factor:'); str(opt.zoom_fac:1:2,fac_str);
         get_str(msg_line,fac_str,stop);
         if not stop then begin
            val(fac_str,opt.zoom_fac,err_code);
            if (err_code=0) and (opt.zoom_fac>0) then begin
               h_mag:=opt.zoom_fac*3; v_mag:=h_mag*asp;
               redraw;
            end else begin
               msg_line:=msg_line+18; message('Error, ENTER !');
               repeat until yes_no(#13,#0);
            end;
         end;
      end;
      2: begin
         message('Zoom area,'); get_area(sx1,sy1,sx2,sy2,stop);
         if not stop then
         if (sx1=sx2) or (sy1=sy2) then begin
            msg_line:=msg_line+18; message('Error, ENTER !');
            repeat until yes_no(#13,#0);
         end else begin
            x0:=x0+sx1/h_mag; y0:=y0+(m_y-sy1)/v_mag;
            x:=m_x/(sx2-sx1); y:=m_y/(sy1-sy2);
            if x<y then opt.zoom_fac:=opt.zoom_fac*x
                   else opt.zoom_fac:=opt.zoom_fac*y;
            h_mag:=opt.zoom_fac*3; v_mag:=h_mag*asp; redraw;
         end;
      end;
      3: begin
         x0:=0; y0:=0; opt.zoom_fac:=1;
         h_mag:=3; v_mag:=h_mag*asp; redraw;
      end;
      4: begin
         h:=opt.zoom_fac; opt.zoom_fac:=last_zoom_fac; last_zoom_fac:=h;
         h:=x0; x0:=last_x0; last_x0:=h;
         h:=y0; y0:=last_y0; last_y0:=h;
         h_mag:=opt.zoom_fac*3; v_mag:=h_mag*asp; redraw;
      end;
   end; {case}
   m_wx:=x0+m_x/h_mag; m_wy:=y0+m_y/v_mag;
   message('');
end; {while}
end; {zoom}

procedure wind;
var wahl,sx,sy:integer;
    x,y:real;
    ende,stop:boolean;
begin
wahl:=1; ende:=false;
while not ende do begin
   funk[0]:='WINDOW';
   funk[1]:='Lower left';
   funk[2]:='Upper right';
   funk[3]:='Origin';
   menu(3,wahl);
   case wahl of
      0: ende:=true;
      1: begin
         message('Lower left corner:'); pict_port;
         get_point(sx,sy,x,y,stop);
         if not stop then begin
            x0:=x; y0:=y; redraw;
            m_wx:=m_wx+x; m_wy:=m_wy+y;
         end;
         message('');
      end;
      2: begin
         message('Upper right corner:'); pict_port;
         get_point(sx,sy,x,y,stop);
         if not stop then begin
            x0:=x0-(m_wx-x); y0:=y0-(m_wy-y); redraw;
            m_wx:=x; m_wy:=y;
         end;
         message('');
      end;
      3: begin
         x0:=0; y0:=0; redraw;
         m_wx:=m_x/h_mag; m_wy:=m_y/v_mag;
      end;
   end; {case}
end;
end; {wind}

procedure snap;
var wahl:integer;
    ende,stop:boolean;
    asp_str:string; code:integer;
begin
wahl:=1; ende:=false;
while not ende do begin
   if opt.snapping then begin
      str(opt.snap_asp,funk[0]);
      funk[0]:='SNAP (On, '+funk[0]+')';
   end else funk[0]:='SNAP (Off)';
   funk[1]:='On';
   funk[2]:='Off';
   funk[3]:='Aspect';
   menu(3,wahl);
   case wahl of
      0: ende:=true;
      1: opt.snapping:=true;
      2: opt.snapping:=false;
      3: begin
         message('Snap-aspect:'); str(opt.snap_asp,asp_str);
         get_str(msg_line,asp_str,stop);
         if (not stop) and (asp_str<>'') then begin
            val(asp_str,opt.snap_asp,code);
            if code<>0 then begin
               opt.snap_asp:=1; msg_line:=msg_line+18;
               message('Error, ENTER !');
               repeat until yes_no(#13,#0);
            end;
         end;
         message('');
      end;
   end; {case}
end;
end; {snap}

procedure directories;
var ende,stop:boolean;
    wahl:integer;
begin
ende:=false; wahl:=1;
while not ende do begin
   funk[0]:='DIRECTORIES';
   funk[1]:='Picture-Directory';
   funk[2]:='Picture-Suffix';
   funk[3]:='Macro-Directory';
   funk[4]:='Macro-Suffix';
   funk[5]:='BGI-Directory';
   menu(5,wahl);
   case wahl of
      0: ende:=true;
      1: begin
         message('Picture-Directory:');
         get_str(msg_line,opt.tex_path,stop);
      end;
      2: begin
         message('Picture-Suffix:');
         get_str(msg_line,opt.tex_suff,stop);
      end;
      3: begin
         message('Macro-Directory:');
         get_str(msg_line,opt.mac_path,stop);
      end;
      4: begin
         message('Macro-Suffix:');
         get_str(msg_line,opt.mac_suff,stop);
      end;
      5: begin
         message('BGI-Directory:');
         get_str(msg_line,opt.driver_path,stop);
      end;
   end; {case}
   message('');
end;
end; {directories}

procedure emlines;
var ende,stop:boolean;
    wahl:integer;
begin
ende:=false; wahl:=1;
while not ende do begin
   if opt.mattes
      then funk[0]:='EMLINES (On, '+opt.linewidth+')'
      else funk[0]:='EMLINES (Off)';
   funk[1]:='On';
   funk[2]:='Off';
   funk[3]:='Linewidth';
   menu(3,wahl);
   case wahl of
      0: ende:=true;
      1: opt.mattes:=true;
      2: opt.mattes:=false;
      3: begin
         message('Linewidth:');
         get_str(msg_line,opt.linewidth,stop);
         message('');
      end;
   end; {case}
   message('');
end;
end; {emlines}

procedure options;
var ende,stop,succ:boolean;
    wahl:integer;
    h_opt:options_type;
begin
ende:=false; wahl:=1;
while not ende do begin
   funk[0]:='OPTIONS';
   funk[1]:='Directories';
   funk[2]:='Snap';
   funk[3]:='Zoom';
   funk[4]:='Unitlength';
   funk[5]:='EMLines';
   funk[6]:='Save Options';
   funk[7]:='Load Options';
   menu(7,wahl);
   case wahl of
      0: ende:=true;
      1: directories;
      2: snap;
      3: zoom;
      4: begin
         message('Unitlength:');
         get_str(msg_line,opt.unitlength,stop);
      end;
      5: emlines;
      6: begin
         message('Options-filename:'); get_str(msg_line,opt_name,stop);
         if not stop then begin
            assign(opt_file,opt_name); succ:=true;
            {$i-} rewrite(opt_file);
            if ioresult=0 then begin
               write(opt_file,opt);
               succ:=ioresult=0;
               close(opt_file);
            end else succ:=false; {$i+}
            if not succ then begin
               msg_line:=msg_line+18;
               message('Error, ENTER !');
               repeat until yes_no(#13,#0);
            end;
         end;
      end;
      7: begin
         message('Options-filename:'); get_str(msg_line,opt_name,stop);
         if not stop then begin
            load_opt(h_opt,succ);
            if succ then begin
               opt:=h_opt;
               h_mag:=opt.zoom_fac*3; v_mag:=h_mag*asp; redraw;
            end else begin
               msg_line:=msg_line+18;
               message('Error, ENTER !');
               repeat until yes_no(#13,#0);
            end;
         end;
      end;
   end; {case}
   message('');
end;
end; {options}

procedure quit;
begin
   if not saved then begin
      message('Picture not saved!'); message('Quit anyway [y/n]?');
      if yes_no('y','n') then halt else message('');
   end else halt;
end; {quit}

begin
   last_x0:=0; last_y0:=0; last_zoom_fac:=1;
end.
